diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.6.pl /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/category-template.php /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/category-template.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/category-template.php	2012-11-20 12:31:06.000000000 -0600
--- /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/category-template.php	2013-06-21 07:45:11.000000000 -0500
***************
*** 37,43 ****
   * @param string $separator Optional, default is '/'. How to separate categories.
   * @param bool $nicename Optional, default is false. Whether to use nice name for display.
   * @param array $visited Optional. Already linked to categories to prevent duplicates.
!  * @return string
   */
  function get_category_parents( $id, $link = false, $separator = '/', $nicename = false, $visited = array() ) {
  	$chain = '';
--- 37,43 ----
   * @param string $separator Optional, default is '/'. How to separate categories.
   * @param bool $nicename Optional, default is false. Whether to use nice name for display.
   * @param array $visited Optional. Already linked to categories to prevent duplicates.
!  * @return string|WP_Error A list of category parents on success, WP_Error on failure.
   */
  function get_category_parents( $id, $link = false, $separator = '/', $nicename = false, $visited = array() ) {
  	$chain = '';
***************
*** 131,137 ****
   * @since 0.71
   *
   * @param int $cat_ID Category ID.
!  * @return string Category name.
   */
  function get_the_category_by_ID( $cat_ID ) {
  	$cat_ID = (int) $cat_ID;
--- 131,137 ----
   * @since 0.71
   *
   * @param int $cat_ID Category ID.
!  * @return string|WP_Error Category name on success, WP_Error on failure.
   */
  function get_the_category_by_ID( $cat_ID ) {
  	$cat_ID = (int) $cat_ID;
***************
*** 671,677 ****
  		$tag_link = '#' != $tag->link ? esc_url( $tag->link ) : '#';
  		$tag_id = isset($tags[ $key ]->id) ? $tags[ $key ]->id : $key;
  		$tag_name = $tags[ $key ]->name;
! 		$a[] = "<a href='$tag_link' class='tag-link-$tag_id' title='" . esc_attr( call_user_func( $topic_count_text_callback, $real_count ) ) . "' style='font-size: " .
  			str_replace( ',', '.', ( $smallest + ( ( $count - $min_count ) * $font_step ) ) )
  			. "$unit;'>$tag_name</a>";
  	}
--- 671,677 ----
  		$tag_link = '#' != $tag->link ? esc_url( $tag->link ) : '#';
  		$tag_id = isset($tags[ $key ]->id) ? $tags[ $key ]->id : $key;
  		$tag_name = $tags[ $key ]->name;
! 		$a[] = "<a href='$tag_link' class='tag-link-$tag_id' title='" . esc_attr( call_user_func( $topic_count_text_callback, $real_count, $tag, $args ) ) . "' style='font-size: " .
  			str_replace( ',', '.', ( $smallest + ( ( $count - $min_count ) * $font_step ) ) )
  			. "$unit;'>$tag_name</a>";
  	}
***************
*** 933,939 ****
  	 * @param int $depth Depth of category. Used for padding.
  	 * @param array $args Uses 'selected' and 'show_count' keys, if they exist.
  	 */
! 	function start_el( &$output, $category, $depth, $args, $id = 0 ) {
  		$pad = str_repeat('&nbsp;', $depth * 3);
  
  		$cat_name = apply_filters('list_cats', $category->name, $category);
--- 933,939 ----
  	 * @param int $depth Depth of category. Used for padding.
  	 * @param array $args Uses 'selected' and 'show_count' keys, if they exist.
  	 */
! 	function start_el( &$output, $category, $depth = 0, $args = array(), $id = 0 ) {
  		$pad = str_repeat('&nbsp;', $depth * 3);
  
  		$cat_name = apply_filters('list_cats', $category->name, $category);
***************
*** 980,986 ****
   * @uses apply_filters() Calls 'get_the_tags' filter on the list of post tags.
   *
   * @param int $id Post ID.
!  * @return array
   */
  function get_the_tags( $id = 0 ) {
  	return apply_filters( 'get_the_tags', get_the_terms( $id, 'post_tag' ) );
--- 980,986 ----
   * @uses apply_filters() Calls 'get_the_tags' filter on the list of post tags.
   *
   * @param int $id Post ID.
!  * @return array|bool Array of tag objects on success, false on failure.
   */
  function get_the_tags( $id = 0 ) {
  	return apply_filters( 'get_the_tags', get_the_terms( $id, 'post_tag' ) );
***************
*** 996,1002 ****
   * @param string $sep Optional. Between tags.
   * @param string $after Optional. After tags.
   * @param int $id Optional. Post ID. Defaults to the current post.
!  * @return string
   */
  function get_the_tag_list( $before = '', $sep = '', $after = '', $id = 0 ) {
  	return apply_filters( 'the_tags', get_the_term_list( $id, 'post_tag', $before, $sep, $after ), $before, $sep, $after, $id );
--- 996,1002 ----
   * @param string $sep Optional. Between tags.
   * @param string $after Optional. After tags.
   * @param int $id Optional. Post ID. Defaults to the current post.
!  * @return string|bool|WP_Error A list of tags on success, false or WP_Error on failure.
   */
  function get_the_tag_list( $before = '', $sep = '', $after = '', $id = 0 ) {
  	return apply_filters( 'the_tags', get_the_term_list( $id, 'post_tag', $before, $sep, $after ), $before, $sep, $after, $id );
***************
*** 1010,1016 ****
   * @param string $before Optional. Before list.
   * @param string $sep Optional. Separate items using this.
   * @param string $after Optional. After list.
-  * @return string
   */
  function the_tags( $before = null, $sep = ', ', $after = '' ) {
  	if ( null === $before )
--- 1010,1015 ----
***************
*** 1054,1062 ****
   *
   * @since 2.5.0
   *
!  * @param mixed $post Post ID or object.
   * @param string $taxonomy Taxonomy name.
!  * @return array|bool False on failure. Array of term objects on success.
   */
  function get_the_terms( $post, $taxonomy ) {
  	if ( ! $post = get_post( $post ) )
--- 1053,1061 ----
   *
   * @since 2.5.0
   *
!  * @param int|object $post Post ID or object.
   * @param string $taxonomy Taxonomy name.
!  * @return array|bool|WP_Error Array of term objects on success, false or WP_Error on failure.
   */
  function get_the_terms( $post, $taxonomy ) {
  	if ( ! $post = get_post( $post ) )
***************
*** 1086,1092 ****
   * @param string $before Optional. Before list.
   * @param string $sep Optional. Separate items using this.
   * @param string $after Optional. After list.
!  * @return string
   */
  function get_the_term_list( $id, $taxonomy, $before = '', $sep = '', $after = '' ) {
  	$terms = get_the_terms( $id, $taxonomy );
--- 1085,1091 ----
   * @param string $before Optional. Before list.
   * @param string $sep Optional. Separate items using this.
   * @param string $after Optional. After list.
!  * @return string|bool|WP_Error A list of terms on success, false or WP_Error on failure.
   */
  function get_the_term_list( $id, $taxonomy, $before = '', $sep = '', $after = '' ) {
  	$terms = get_the_terms( $id, $taxonomy );
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.6.pl /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/class-feed.php /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/class-feed.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/class-feed.php	2013-06-21 01:12:17.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/class-feed.php	2013-07-31 01:53:06.000000000 -0500
***************
*** 69,75 ****
  			$args = array(
  				'timeout' => $this->timeout,
  				'redirection' => $this->redirects,
- 				'reject_unsafe_urls' => true,
  			);
  
  			if ( !empty($this->headers) )
--- 69,74 ----
***************
*** 78,84 ****
  			if ( SIMPLEPIE_USERAGENT != $this->useragent ) //Use default WP user agent unless custom has been specified
  				$args['user-agent'] = $this->useragent;
  
! 			$res = wp_remote_request($url, $args);
  
  			if ( is_wp_error($res) ) {
  				$this->error = 'WP HTTP Error: ' . $res->get_error_message();
--- 77,83 ----
  			if ( SIMPLEPIE_USERAGENT != $this->useragent ) //Use default WP user agent unless custom has been specified
  				$args['user-agent'] = $this->useragent;
  
! 			$res = wp_safe_remote_request($url, $args);
  
  			if ( is_wp_error($res) ) {
  				$this->error = 'WP HTTP Error: ' . $res->get_error_message();
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.6.pl /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/class-http.php /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/class-http.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/class-http.php	2013-06-21 14:32:36.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/class-http.php	2013-07-30 13:41:03.000000000 -0500
***************
*** 96,102 ****
  			'decompress' => true,
  			'sslverify' => true,
  			'stream' => false,
! 			'filename' => null
  		);
  
  		// Pre-parse for the HEAD checks.
--- 96,103 ----
  			'decompress' => true,
  			'sslverify' => true,
  			'stream' => false,
! 			'filename' => null,
! 			'limit_response_size' => null,
  		);
  
  		// Pre-parse for the HEAD checks.
***************
*** 118,127 ****
  		if ( false !== $pre )
  			return $pre;
  
! 		if ( $r['reject_unsafe_urls'] )
! 			$url = wp_http_validate_url( $url );
! 		if ( function_exists( 'wp_kses_bad_protocol' ) )
  			$url = wp_kses_bad_protocol( $url, array( 'http', 'https', 'ssl' ) );
  
  		$arrURL = @parse_url( $url );
  
--- 119,129 ----
  		if ( false !== $pre )
  			return $pre;
  
! 		if ( function_exists( 'wp_kses_bad_protocol' ) ) {
! 			if ( $r['reject_unsafe_urls'] )
! 				$url = wp_http_validate_url( $url );
  			$url = wp_kses_bad_protocol( $url, array( 'http', 'https', 'ssl' ) );
+ 		}
  
  		$arrURL = @parse_url( $url );
  
***************
*** 141,154 ****
  		unset( $homeURL );
  
  		// If we are streaming to a file but no filename was given drop it in the WP temp dir
! 		// and pick it's name using the basename of the $url
  		if ( $r['stream']  && empty( $r['filename'] ) )
  			$r['filename'] = get_temp_dir() . basename( $url );
  
  		// Force some settings if we are streaming to a file and check for existence and perms of destination directory
  		if ( $r['stream'] ) {
  			$r['blocking'] = true;
! 			if ( ! call_user_func( 'WIN' === strtoupper( substr( PHP_OS, 0, 3 ) ) ? 'win_is_writable' : 'is_writable', dirname( $r['filename'] ) ) )
  				return new WP_Error( 'http_request_failed', __( 'Destination directory for file streaming does not exist or is not writable.' ) );
  		}
  
--- 143,156 ----
  		unset( $homeURL );
  
  		// If we are streaming to a file but no filename was given drop it in the WP temp dir
! 		// and pick its name using the basename of the $url
  		if ( $r['stream']  && empty( $r['filename'] ) )
  			$r['filename'] = get_temp_dir() . basename( $url );
  
  		// Force some settings if we are streaming to a file and check for existence and perms of destination directory
  		if ( $r['stream'] ) {
  			$r['blocking'] = true;
! 			if ( ! wp_is_writable( dirname( $r['filename'] ) ) )
  				return new WP_Error( 'http_request_failed', __( 'Destination directory for file streaming does not exist or is not writable.' ) );
  		}
  
***************
*** 173,180 ****
  		// Construct Cookie: header if any cookies are set
  		WP_Http::buildCookieHeader( $r );
  
! 		if ( WP_Http_Encoding::is_available() )
! 			$r['headers']['Accept-Encoding'] = WP_Http_Encoding::accept_encoding();
  
  		if ( ( ! is_null( $r['body'] ) && '' != $r['body'] ) || 'POST' == $r['method'] || 'PUT' == $r['method'] ) {
  			if ( is_array( $r['body'] ) || is_object( $r['body'] ) ) {
--- 175,184 ----
  		// Construct Cookie: header if any cookies are set
  		WP_Http::buildCookieHeader( $r );
  
! 		if ( ! isset( $r['headers']['Accept-Encoding'] ) ) {
! 			if ( $encoding = WP_Http_Encoding::accept_encoding( $url, $r ) )
! 				$r['headers']['Accept-Encoding'] = $encoding;
! 		}
  
  		if ( ( ! is_null( $r['body'] ) && '' != $r['body'] ) || 'POST' == $r['method'] || 'PUT' == $r['method'] ) {
  			if ( is_array( $r['body'] ) || is_object( $r['body'] ) ) {
***************
*** 328,334 ****
  	 * @param string $strResponse The full response string
  	 * @return array Array with 'headers' and 'body' keys.
  	 */
! 	function processResponse($strResponse) {
  		$res = explode("\r\n\r\n", $strResponse, 2);
  
  		return array('headers' => $res[0], 'body' => isset($res[1]) ? $res[1] : '');
--- 332,338 ----
  	 * @param string $strResponse The full response string
  	 * @return array Array with 'headers' and 'body' keys.
  	 */
! 	public static function processResponse($strResponse) {
  		$res = explode("\r\n\r\n", $strResponse, 2);
  
  		return array('headers' => $res[0], 'body' => isset($res[1]) ? $res[1] : '');
***************
*** 537,543 ****
  		if ( !empty($wildcard_regex) )
  			return !preg_match($wildcard_regex, $check['host']);
  		else
! 			return !in_array( $check['host'], $accessible_hosts ); //Inverse logic, If its in the array, then we can't access it.
  
  	}
  
--- 541,547 ----
  		if ( !empty($wildcard_regex) )
  			return !preg_match($wildcard_regex, $check['host']);
  		else
! 			return !in_array( $check['host'], $accessible_hosts ); //Inverse logic, If it's in the array, then we can't access it.
  
  	}
  
***************
*** 562,568 ****
  		// Start off with the Absolute URL path
  		$path = ! empty( $url_parts['path'] ) ? $url_parts['path'] : '/';
  
! 		// If the it's a root-relative path, then great
  		if ( ! empty( $relative_url_parts['path'] ) && '/' == $relative_url_parts['path'][0] ) {
  			$path = $relative_url_parts['path'];
  
--- 566,572 ----
  		// Start off with the Absolute URL path
  		$path = ! empty( $url_parts['path'] ) ? $url_parts['path'] : '/';
  
! 		// If it's a root-relative path, then great
  		if ( ! empty( $relative_url_parts['path'] ) && '/' == $relative_url_parts['path'][0] ) {
  			$path = $relative_url_parts['path'];
  
***************
*** 738,743 ****
--- 742,751 ----
  
  		$strResponse = '';
  		$bodyStarted = false;
+ 		$keep_reading = true;
+ 		$block_size = 4096;
+ 		if ( isset( $r['limit_response_size'] ) )
+ 			$block_size = min( $block_size, $r['limit_response_size'] );
  
  		// If streaming to a file setup the file handle
  		if ( $r['stream'] ) {
***************
*** 748,774 ****
  			if ( ! $stream_handle )
  				return new WP_Error( 'http_request_failed', sprintf( __( 'Could not open handle for fopen() to %s' ), $r['filename'] ) );
  
! 			while ( ! feof($handle) ) {
! 				$block = fread( $handle, 4096 );
! 				if ( $bodyStarted ) {
! 					fwrite( $stream_handle, $block );
! 				} else {
  					$strResponse .= $block;
  					if ( strpos( $strResponse, "\r\n\r\n" ) ) {
  						$process = WP_Http::processResponse( $strResponse );
  						$bodyStarted = true;
! 						fwrite( $stream_handle, $process['body'] );
  						unset( $strResponse );
  						$process['body'] = '';
  					}
  				}
  			}
  
  			fclose( $stream_handle );
  
  		} else {
! 			while ( ! feof($handle) )
! 				$strResponse .= fread( $handle, 4096 );
  
  			$process = WP_Http::processResponse( $strResponse );
  			unset( $strResponse );
--- 756,796 ----
  			if ( ! $stream_handle )
  				return new WP_Error( 'http_request_failed', sprintf( __( 'Could not open handle for fopen() to %s' ), $r['filename'] ) );
  
! 			$bytes_written = 0;
! 			while ( ! feof($handle) && $keep_reading ) {
! 				$block = fread( $handle, $block_size );
! 				if ( ! $bodyStarted ) {
  					$strResponse .= $block;
  					if ( strpos( $strResponse, "\r\n\r\n" ) ) {
  						$process = WP_Http::processResponse( $strResponse );
  						$bodyStarted = true;
! 						$block = $process['body'];
  						unset( $strResponse );
  						$process['body'] = '';
  					}
  				}
+ 
+ 				if ( isset( $r['limit_response_size'] ) && ( $bytes_written + strlen( $block ) ) > $r['limit_response_size'] )
+ 					$block = substr( $block, 0, ( $r['limit_response_size'] - $bytes_written ) );
+ 
+ 				$bytes_written += fwrite( $stream_handle, $block );
+ 
+ 				$keep_reading = !isset( $r['limit_response_size'] ) || $bytes_written < $r['limit_response_size'];
  			}
  
  			fclose( $stream_handle );
  
  		} else {
! 			$header_length = 0;
! 			while ( ! feof( $handle ) && $keep_reading ) {
! 				$block = fread( $handle, $block_size );
! 				$strResponse .= $block;
! 				if ( ! $bodyStarted && strpos( $strResponse, "\r\n\r\n" ) ) {
! 					$header_length = strpos( $strResponse, "\r\n\r\n" ) + 4;
! 					$bodyStarted = true;
! 				}
! 				$keep_reading = ( ! $bodyStarted || !isset( $r['limit_response_size'] ) || strlen( $strResponse ) < ( $header_length + $r['limit_response_size'] ) );
! 			}
  
  			$process = WP_Http::processResponse( $strResponse );
  			unset( $strResponse );
***************
*** 797,802 ****
--- 820,828 ----
  		if ( true === $r['decompress'] && true === WP_Http_Encoding::should_decode($arrHeaders['headers']) )
  			$process['body'] = WP_Http_Encoding::decompress( $process['body'] );
  
+ 		if ( isset( $r['limit_response_size'] ) && strlen( $process['body'] ) > $r['limit_response_size'] )
+ 			$process['body'] = substr( $process['body'], 0, $r['limit_response_size'] );
+ 
  		return array( 'headers' => $arrHeaders['headers'], 'body' => $process['body'], 'response' => $arrHeaders['response'], 'cookies' => $arrHeaders['cookies'], 'filename' => $r['filename'] );
  	}
  
***************
*** 941,946 ****
--- 967,973 ----
  			return array( 'headers' => array(), 'body' => '', 'response' => array('code' => false, 'message' => false), 'cookies' => array() );
  		}
  
+ 		$max_bytes = isset( $r['limit_response_size'] ) ? intval( $r['limit_response_size'] ) : -1;
  		if ( $r['stream'] ) {
  			if ( ! WP_DEBUG )
  				$stream_handle = @fopen( $r['filename'], 'w+' );
***************
*** 950,961 ****
  			if ( ! $stream_handle )
  				return new WP_Error( 'http_request_failed', sprintf( __( 'Could not open handle for fopen() to %s' ), $r['filename'] ) );
  
! 			stream_copy_to_stream( $handle, $stream_handle );
  
  			fclose( $stream_handle );
  			$strResponse = '';
  		} else {
! 			$strResponse = stream_get_contents( $handle );
  		}
  
  		$meta = stream_get_meta_data( $handle );
--- 977,988 ----
  			if ( ! $stream_handle )
  				return new WP_Error( 'http_request_failed', sprintf( __( 'Could not open handle for fopen() to %s' ), $r['filename'] ) );
  
! 			stream_copy_to_stream( $handle, $stream_handle, $max_bytes );
  
  			fclose( $stream_handle );
  			$strResponse = '';
  		} else {
! 			$strResponse = stream_get_contents( $handle, $max_bytes );
  		}
  
  		$meta = stream_get_meta_data( $handle );
***************
*** 1022,1028 ****
  class WP_Http_Curl {
  
  	/**
! 	 * Temporary header storage for use with streaming to a file.
  	 *
  	 * @since 3.2.0
  	 * @access private
--- 1049,1055 ----
  class WP_Http_Curl {
  
  	/**
! 	 * Temporary header storage for during requests.
  	 *
  	 * @since 3.2.0
  	 * @access private
***************
*** 1031,1036 ****
--- 1058,1090 ----
  	private $headers = '';
  
  	/**
+ 	 * Temporary body storage for during requests.
+ 	 *
+ 	 * @since 3.6.0
+ 	 * @access private
+ 	 * @var string
+ 	 */
+ 	private $body = '';
+ 
+ 	/**
+ 	 * The maximum amount of data to recieve from the remote server
+ 	 *
+ 	 * @since 3.6.0
+ 	 * @access private
+ 	 * @var int
+ 	 */
+ 	private $max_body_length = false;
+ 
+ 	/**
+ 	 * The file resource used for streaming to file.
+ 	 *
+ 	 * @since 3.6.0
+ 	 * @access private
+ 	 * @var resource
+ 	 */
+ 	private $stream_handle = false;
+ 
+ 	/**
  	 * Send a HTTP request to a URI using cURL extension.
  	 *
  	 * @access public
***************
*** 1121,1140 ****
  				break;
  		}
  
! 		if ( true === $r['blocking'] )
  			curl_setopt( $handle, CURLOPT_HEADERFUNCTION, array( $this, 'stream_headers' ) );
  
  		curl_setopt( $handle, CURLOPT_HEADER, false );
  
  		// If streaming to a file open a file handle, and setup our curl streaming handler
  		if ( $r['stream'] ) {
  			if ( ! WP_DEBUG )
! 				$stream_handle = @fopen( $r['filename'], 'w+' );
  			else
! 				$stream_handle = fopen( $r['filename'], 'w+' );
! 			if ( ! $stream_handle )
  				return new WP_Error( 'http_request_failed', sprintf( __( 'Could not open handle for fopen() to %s' ), $r['filename'] ) );
! 			curl_setopt( $handle, CURLOPT_FILE, $stream_handle );
  		}
  
  		if ( !empty( $r['headers'] ) ) {
--- 1175,1202 ----
  				break;
  		}
  
! 		if ( true === $r['blocking'] ) {
  			curl_setopt( $handle, CURLOPT_HEADERFUNCTION, array( $this, 'stream_headers' ) );
+ 			curl_setopt( $handle, CURLOPT_WRITEFUNCTION, array( $this, 'stream_body' ) );
+ 		}
  
  		curl_setopt( $handle, CURLOPT_HEADER, false );
  
+ 		if ( isset( $r['limit_response_size'] ) )
+ 			$this->max_body_length = intval( $r['limit_response_size'] );
+ 		else
+ 			$this->max_body_length = false;
+ 
  		// If streaming to a file open a file handle, and setup our curl streaming handler
  		if ( $r['stream'] ) {
  			if ( ! WP_DEBUG )
! 				$this->stream_handle = @fopen( $r['filename'], 'w+' );
  			else
! 				$this->stream_handle = fopen( $r['filename'], 'w+' );
! 			if ( ! $this->stream_handle )
  				return new WP_Error( 'http_request_failed', sprintf( __( 'Could not open handle for fopen() to %s' ), $r['filename'] ) );
! 		} else {
! 			$this->stream_handle = false;
  		}
  
  		if ( !empty( $r['headers'] ) ) {
***************
*** 1158,1184 ****
  		// We don't need to return the body, so don't. Just execute request and return.
  		if ( ! $r['blocking'] ) {
  			curl_exec( $handle );
  			curl_close( $handle );
  			return array( 'headers' => array(), 'body' => '', 'response' => array('code' => false, 'message' => false), 'cookies' => array() );
  		}
  
  		$theResponse = curl_exec( $handle );
- 		$theBody = '';
  		$theHeaders = WP_Http::processHeaders( $this->headers );
  
! 		if ( strlen($theResponse) > 0 && ! is_bool( $theResponse ) ) // is_bool: when using $args['stream'], curl_exec will return (bool)true
! 			$theBody = $theResponse;
  
  		// If no response
! 		if ( 0 == strlen( $theResponse ) && empty( $theHeaders['headers'] ) ) {
! 			if ( $curl_error = curl_error( $handle ) )
  				return new WP_Error( 'http_request_failed', $curl_error );
! 			if ( in_array( curl_getinfo( $handle, CURLINFO_HTTP_CODE ), array( 301, 302 ) ) )
  				return new WP_Error( 'http_request_failed', __( 'Too many redirects.' ) );
  		}
  
- 		$this->headers = '';
- 
  		$response = array();
  		$response['code'] = curl_getinfo( $handle, CURLINFO_HTTP_CODE );
  		$response['message'] = get_status_header_desc($response['code']);
--- 1220,1258 ----
  		// We don't need to return the body, so don't. Just execute request and return.
  		if ( ! $r['blocking'] ) {
  			curl_exec( $handle );
+ 
+ 			if ( $curl_error = curl_error( $handle ) ) {
+ 				curl_close( $handle );
+ 				return new WP_Error( 'http_request_failed', $curl_error );
+ 			}
+ 			if ( in_array( curl_getinfo( $handle, CURLINFO_HTTP_CODE ), array( 301, 302 ) ) ) {
+ 				curl_close( $handle );
+ 				return new WP_Error( 'http_request_failed', __( 'Too many redirects.' ) );
+ 			}
+ 
  			curl_close( $handle );
  			return array( 'headers' => array(), 'body' => '', 'response' => array('code' => false, 'message' => false), 'cookies' => array() );
  		}
  
  		$theResponse = curl_exec( $handle );
  		$theHeaders = WP_Http::processHeaders( $this->headers );
+ 		$theBody = $this->body;
  
! 		$this->headers = '';
! 		$this->body = '';
  
  		// If no response
! 		if ( 0 == strlen( $theBody ) && empty( $theHeaders['headers'] ) ) {
! 			if ( $curl_error = curl_error( $handle ) ) {
! 				curl_close( $handle );
  				return new WP_Error( 'http_request_failed', $curl_error );
! 			}
! 			if ( in_array( curl_getinfo( $handle, CURLINFO_HTTP_CODE ), array( 301, 302 ) ) ) {
! 				curl_close( $handle );
  				return new WP_Error( 'http_request_failed', __( 'Too many redirects.' ) );
+ 			}
  		}
  
  		$response = array();
  		$response['code'] = curl_getinfo( $handle, CURLINFO_HTTP_CODE );
  		$response['message'] = get_status_header_desc($response['code']);
***************
*** 1186,1192 ****
  		curl_close( $handle );
  
  		if ( $r['stream'] )
! 			fclose( $stream_handle );
  
  		// See #11305 - When running under safe mode, redirection is disabled above. Handle it manually.
  		if ( ! empty( $theHeaders['headers']['location'] ) && 0 !== $r['_redirection'] ) { // _redirection: The requested number of redirections
--- 1260,1266 ----
  		curl_close( $handle );
  
  		if ( $r['stream'] )
! 			fclose( $this->stream_handle );
  
  		// See #11305 - When running under safe mode, redirection is disabled above. Handle it manually.
  		if ( ! empty( $theHeaders['headers']['location'] ) && 0 !== $r['_redirection'] ) { // _redirection: The requested number of redirections
***************
*** 1218,1223 ****
--- 1292,1319 ----
  	}
  
  	/**
+ 	 * Grab the body of the cURL request
+ 	 *
+ 	 * The contents of the document are passed in chunks, so we append to the $body property for temporary storage.
+ 	 * Returning a length shorter than the length of $data passed in will cause cURL to abort the request as "completed"
+ 	 *
+ 	 * @since 3.6.0
+ 	 * @access private
+ 	 * @return int
+ 	 */
+ 	private function stream_body( $handle, $data ) {
+ 		if ( $this->max_body_length && ( strlen( $this->body ) + strlen( $data ) ) > $this->max_body_length )
+ 			$data = substr( $data, 0, ( $this->max_body_length - strlen( $this->body ) ) );
+ 
+ 		if ( $this->stream_handle )
+ 			fwrite( $this->stream_handle, $data );
+ 		else
+ 			$this->body .= $data;
+ 
+ 		return strlen( $data );
+ 	}
+ 
+ 	/**
  	 * Whether this class can be used for retrieving an URL.
  	 *
  	 * @static
***************
*** 1743,1758 ****
  	 *
  	 * @return string Types of encoding to accept.
  	 */
! 	public static function accept_encoding() {
  		$type = array();
! 		if ( function_exists( 'gzinflate' ) )
! 			$type[] = 'deflate;q=1.0';
  
! 		if ( function_exists( 'gzuncompress' ) )
! 			$type[] = 'compress;q=0.5';
  
! 		if ( function_exists( 'gzdecode' ) )
! 			$type[] = 'gzip;q=0.5';
  
  		return implode(', ', $type);
  	}
--- 1839,1867 ----
  	 *
  	 * @return string Types of encoding to accept.
  	 */
! 	public static function accept_encoding( $url, $args ) {
  		$type = array();
! 		$compression_enabled = WP_Http_Encoding::is_available();
! 
! 		if ( ! $args['decompress'] ) // decompression specifically disabled
! 			$compression_enabled = false;
! 		elseif ( $args['stream'] ) // disable when streaming to file
! 			$compression_enabled = false;
! 		elseif ( isset( $args['limit_response_size'] ) ) // If only partial content is being requested, we won't be able to decompress it
! 			$compression_enabled = false;
  
! 		if ( $compression_enabled ) {
! 			if ( function_exists( 'gzinflate' ) )
! 				$type[] = 'deflate;q=1.0';
! 
! 			if ( function_exists( 'gzuncompress' ) )
! 				$type[] = 'compress;q=0.5';
! 
! 			if ( function_exists( 'gzdecode' ) )
! 				$type[] = 'gzip;q=0.5';
! 		}
  
! 		$type = apply_filters( 'wp_http_accept_encoding', $type, $url, $args );
  
  		return implode(', ', $type);
  	}
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.6.pl /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/class-json.php /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/class-json.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/class-json.php	2012-11-21 16:31:55.000000000 -0600
--- /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/class-json.php	2013-07-08 11:55:34.000000000 -0500
***************
*** 1,5 ****
  <?php
! if ( !class_exists( 'Services_JSON' ) ) :
  /* vim: set expandtab tabstop=4 shiftwidth=4 softtabstop=4: */
  /**
   * Converts to and from JSON format.
--- 1,5 ----
  <?php
! if ( ! class_exists( 'Services_JSON' ) ) :
  /* vim: set expandtab tabstop=4 shiftwidth=4 softtabstop=4: */
  /**
   * Converts to and from JSON format.
***************
*** 46,65 ****
   * DAMAGE.
   *
   * @category
!  * @package		Services_JSON
!  * @author		Michal Migurski <mike-json@teczno.com>
!  * @author		Matt Knapp <mdknapp[at]gmail[dot]com>
!  * @author		Brett Stimmerman <brettstimmerman[at]gmail[dot]com>
!  * @copyright	2005 Michal Migurski
!  * @version     CVS: $Id: JSON.php 288200 2009-09-09 15:41:29Z alan_k $
!  * @license		http://www.opensource.org/licenses/bsd-license.php
!  * @link		http://pear.php.net/pepr/pepr-proposal-show.php?id=198
   */
  
  /**
   * Marker constant for Services_JSON::decode(), used to flag stack state
   */
! define('SERVICES_JSON_SLICE', 1);
  
  /**
   * Marker constant for Services_JSON::decode(), used to flag stack state
--- 46,65 ----
   * DAMAGE.
   *
   * @category
!  * @package     Services_JSON
!  * @author      Michal Migurski <mike-json@teczno.com>
!  * @author      Matt Knapp <mdknapp[at]gmail[dot]com>
!  * @author      Brett Stimmerman <brettstimmerman[at]gmail[dot]com>
!  * @copyright   2005 Michal Migurski
!  * @version     CVS: $Id: JSON.php 305040 2010-11-02 23:19:03Z alan_k $
!  * @license     http://www.opensource.org/licenses/bsd-license.php
!  * @link        http://pear.php.net/pepr/pepr-proposal-show.php?id=198
   */
  
  /**
   * Marker constant for Services_JSON::decode(), used to flag stack state
   */
! define('SERVICES_JSON_SLICE',   1);
  
  /**
   * Marker constant for Services_JSON::decode(), used to flag stack state
***************
*** 92,97 ****
--- 92,102 ----
  define('SERVICES_JSON_SUPPRESS_ERRORS', 32);
  
  /**
+  * Behavior switch for Services_JSON::decode()
+  */
+ define('SERVICES_JSON_USE_TO_JSON', 64);
+ 
+ /**
   * Converts to and from JSON format.
   *
   * Brief example of use:
